<?php
     class FILES
     {
        var $file_topics;
        var $file_answers;

        function FILES() {
			$dataDir = '../data/';
			if (!file_exists($dataDir)) {
				mkdir($dataDir);
				chmod($dataDir, 0777);
			}
			$this->file_topics  = $dataDir . $GLOBALS['mass_settings']['module_id'].'_topics.txt';
			$this->file_answers = $dataDir . $GLOBALS['mass_settings']['module_id'].'_answers.txt';
			if(!file_exists($this->file_topics)) {
				$fp = @fopen($this->file_topics,"w");
				@fclose($fp);
			}
			if(!file_exists($this->file_answers)) {
				$fp = @fopen($this->file_answers,"w");
				@fclose($fp);
			}
        }
        
        function getTopics()
        {
           $mass = $this->get_all_mass_topics();
           return $mass;
        }

        function getAnswersByTopic($id_topic)
        {
           $mass = $this->get_mass_answers_by_topic($id_topic);
           return $mass;
        }
        
        function get_file_content($path_file)
        {
           if(!is_readable($path_file)) return array();
           $file_content = implode("", file($path_file));
           $file_content = str_replace("\n","",$file_content);
           $file_content = str_replace("\r","",$file_content);
           $file_content = str_replace("\t","",$file_content);
           $file_content = trim($file_content);
           return $file_content;
        }

        function set_file_content($path_file,$content)
        {
            $fp = fopen($path_file,"w");
            flock($fp, LOCK_EX);
            fwrite($fp, $content);
            flock($fp, LOCK_UN);
            fclose($fp);
        }

        function get_all_mass_topics()
        {
             $file_content = $this->get_file_content($this->file_topics);
             $mass = unserialize($file_content);

             if(!isset($file_content) || $file_content=="")   return array();
             return $mass;
        }
        
        function get_topic($id_topic)
        {
             $mass = $this->get_all_mass_topics();

             foreach($mass as $k => $value)
                      if($id_topic==$value[0])
                          return $value;
             return "";
        }

        function get_all_mass_answers()
        {
             $file_content = $this->get_file_content($this->file_answers);
             $mass = unserialize($file_content);

             if(!isset($file_content) || $file_content=="")   return array();
             return $mass;
        }
        
        function get_mass_answers_by_topic($id_topics)
        {
             $result = array();
             $mass = $this->get_all_mass_answers();
             foreach($mass as $k => $value)
                 if($id_topics==$value[1])
                      $result[] = $value;
             return $result;
        }

        function set_serialize_mass_topics($topic)
        {
             $mass = $this->get_all_mass_topics();
             if($mass==""){
                 $mass[0] = $topic;
             }else{
                 $index = sizeof($mass);
                 $mass[$index] = $topic;
                 krsort($mass);
             }
             $this->set_file_content($this->file_topics,serialize($mass));
        }

        function set_serialize_mass_answers($answer)
        {
             $mass = $this->get_all_mass_answers();
             if($mass==""){
                 $mass[0] = $answer;
             }else{
                 $index = sizeof($mass);
                 $mass[$index] = $answer;
             }
             $this->set_file_content($this->file_answers,serialize($mass));
        }

        function addTopic($topic)
        {
             $this->set_serialize_mass_topics($topic);
        }

        function add_new_answer($answer)
        {
             $this->set_serialize_mass_answers($answer);
        }

        function increment_decrement_count_answers($id_topic,$count)
        {
             $mass = $this->get_all_mass_topics();
             $id_topic = intval($id_topic);

             foreach($mass as $k => $value){
                  if($id_topic==$value[0]){
                       $key = $k;
                       $kol_ans = intval($value[6])+$count;
                       break;
                  }
             }
             $mass[$key][6]=$kol_ans;
             $topics = serialize($mass);
             $this->set_file_content($this->file_topics,$topics);
        }
        
        function edit_answer($mass_vars)
        {
             $result = array();
             $mass_answers = $this->get_all_mass_answers();
             $id = intval($mass_vars["user_id"]);
             
             foreach($mass_answers as $k => $value)
             {
                if($value[0]==$id){
                   $result[$k][0] = $mass_answers[$k][0];
                   $result[$k][1] = $mass_answers[$k][1];
                   $result[$k][2] = $mass_vars["nick"];
                   $result[$k][3] = $mass_vars["content"];
                   $result[$k][4] = $mass_vars["signature"];
                   $result[$k][5] = $mass_vars["link"];
                   $result[$k][6] = $mass_answers[$k][6];
                }else{
                   $result[$k] = $mass_answers[$k];
                }
             }
             
             $answers = serialize($result);
             $this->set_file_content($this->file_answers,$answers);
        }
        
        function delete_answer($id_answer)
        {
             $result = array();
             $mass_answers = $this->get_all_mass_answers();
             foreach($mass_answers as $k => $value)
             {
                if($value[0]!=$id_answer)
                    $result[] = $mass_answers[$k];
             }
             $mass_answers = serialize($result);
             $this->set_file_content($this->file_answers,$mass_answers);
        }
        
        function close_db()
        {
        
        }
     }


    class SQLITE
    {
        var $con;

        function SQLITE() {
            if (!function_exists("sqlite_open"))  {
                  echo "On a host the extension sqlite.so is not used. Please contact your administrator.";
                  exit();
            }
			$dataDir = '../data/';
			if (!file_exists($dataDir)) {
				mkdir($dataDir);
				chmod($dataDir, 0777);
			}
        	$sqlite_file = $dataDir . $GLOBALS['mass_settings']['module_id'].'.bin';
		    if (!file_exists($sqlite_file)) {
		    	  $db = sqlite_open($sqlite_file);
  				  sqlite_query($db, 
   				    "CREATE TABLE list_topics (
						time_create CHAR(50),
	                    name_topic CHAR(50),
						nick CHAR(30),
						content TEXT,
						signature CHAR(30),
						link CHAR(30),
						count_answers INTEGER,
						sess_id CHAR(50) )"
		   		  );
				  sqlite_query($db,
                  	"CREATE TABLE list_answers (
						time_create CHAR(50),
						id_topic CHAR(50),
						nick CHAR(30),
						content TEXT,
						signature CHAR(30),
						link CHAR(30),
						sess_id CHAR(50) )"
                  );
		    }
			$this->con = @sqlite_open($sqlite_file);
        }

		function getQuery($sql)
		{
			$result = sqlite_query($this->con, $sql);			
			return $result;			$this->close_db();           
		}
		
		function setQuery($sql)
		{
			sqlite_query($this->con, $sql);
		}
          
        function fetch_array($result)
        {
           return sqlite_fetch_array($result);
        }
          
        function close_db()
        {
           sqlite_close($this->con);
        }
          
        function getTopics()
        {
            $mass = array();
            $sql = "SELECT * FROM list_topics ORDER BY time_create DESC";
            $result = $this->getQuery($sql);
            while($row = $this->fetch_array($result))
            {
                $mass[] = $row;
            }
            return $mass;
        }
        
        function getAnswersByTopic($id_topic)
        {
            $mass = array();
            $sql = "SELECT * FROM list_answers WHERE id_topic=$id_topic ORDER BY time_create";
            $result = $this->getQuery($sql);
            while($row = $this->fetch_array($result))
            {
                $mass[] = $row;
            }
            return $mass;
        }
        
        function get_topic($id_topic)
        {
            $mass = array();
            $sql = "SELECT * FROM list_topics WHERE time_create=$id_topic";
            $result = $this->getQuery($sql);

            if($row = $this->fetch_array($result))
            {
                $mass = $row;
            }
            return $mass;
        }
        
        function addTopic($content_topic)
        {
            $sql = "INSERT INTO list_topics (time_create, name_topic, nick, content, signature, link, count_answers, sess_id)
                                     VALUES ('$content_topic[0]','$content_topic[1]','$content_topic[2]','$content_topic[3]','$content_topic[4]','$content_topic[5]','$content_topic[6]','$content_topic[7]')";
            $this->setQuery($sql);
        }
        
        function add_new_answer($answer)
        {
            $sql = "INSERT INTO list_answers (time_create, id_topic, nick, content, signature, link, sess_id)
                                                 VALUES  ('$answer[0]','$answer[1]','$answer[2]','$answer[3]','$answer[4]','$answer[5]','$answer[6]')";
            $this->setQuery($sql);
        }
        
        function increment_decrement_count_answers($id_topic,$count)
        {
            $sql = "UPDATE list_topics SET count_answers=count_answers+'$count' WHERE time_create=$id_topic";
            $this->setQuery($sql);
        }
        
        function edit_answer($mass_vars)
        {
            $id = intval($mass_vars["user_id"]);
            $nick = $mass_vars["nick"];
            $content = $mass_vars["content"];
            $signature = $mass_vars["signature"];
            $link = $mass_vars["link"];

            $sql = "UPDATE list_answers SET nick='$nick', content='$content', signature='$signature', link='$link' WHERE time_create=$id";
            $this->setQuery($sql);
        }
        
        function delete_answer($answer_id)
        {
            $sql = "DELETE FROM list_answers WHERE time_create=$answer_id";
            $this->setQuery($sql);
        }

        function get_all_mass_answers()
        {
            $mass = array();
            $sql = "SELECT * FROM list_answers";
            $result = $this->getQuery($sql);

            if($row = $this->fetch_array($result))
            {
                $mass[] = $row;
            }
            return $mass;
        }
    }
    
    class MYSQL
    {
          var $con;
          var $module_id;

          function mysql($host,$user,$passwd,$db_name,$module_id)
          {
              $this->module_id = $module_id;
              if(!function_exists("mysql_connect"))
              {
                  echo "On this host database Mysql don't use";
                  exit();
              }
               
              $this->con = @mysql_connect($host,$user,$passwd) or die(mysql_error());
              $sql = "CREATE DATABASE IF NOT EXISTS ".$db_name;
              $this->setQuery($sql);

              @mysql_select_db($db_name)  or die(mysql_error());
              $sql = "CREATE TABLE IF NOT EXISTS ".$module_id."_list_topics
                      (
                           time_create varchar(50),
                           name_topic varchar(50),
                           nick varchar(30),
                           content TEXT,
                           signature varchar(30),
                           link varchar(30),
                           count_answers int(4),
                           sess_id varchar(50)
                      )";
              $this->setQuery($sql);

              $sql = "CREATE TABLE IF NOT EXISTS ".$module_id."_list_answers
                      (
                           time_create varchar(50),
                           id_topic varchar(50),
                           nick varchar(30),
                           content TEXT,
                           signature varchar(30),
                           link varchar(30),
                           sess_id varchar(50)
                      )";
              $this->setQuery($sql);

          }

          function getQuery($sql)
          {
               $result = mysql_query($sql,$this->con);
               return $result;
          }

          function setQuery($sql)
          {
               @mysql_query($sql,$this->con) or die(mysql_error());
          }

          function fetch_array($result)
          {
               $result = @mysql_fetch_array($result);
               return $result;
          }

          function close_db()
          {
               mysql_close($this->con);
          }
          
        function getTopics()
        {
            $mass = array();
            $sql = "SELECT * FROM ".$this->module_id."_list_topics ORDER BY time_create DESC";
            $result = $this->getQuery($sql);
            while($row = $this->fetch_array($result))
            {
                $mass[] = $row;
            }
            return $mass;
        }

        function getAnswersByTopic($id_topic)
        {
            $mass = array();
            $sql = "SELECT * FROM ".$this->module_id."_list_answers WHERE id_topic=$id_topic ORDER BY time_create";
            $result = $this->getQuery($sql);
            while($row = $this->fetch_array($result))
            {
                $mass[] = $row;
            }
            return $mass;
        }

        function get_topic($id_topic)
        {
            $mass = array();
            $sql = "SELECT * FROM ".$this->module_id."_list_topics WHERE time_create=$id_topic";
            $result = $this->getQuery($sql);

            if($row = $this->fetch_array($result))
            {
                $mass = $row;
            }
            return $mass;
        }

        function addTopic($content_topic)
        {
            $sql = "INSERT INTO ".$this->module_id."_list_topics (time_create, name_topic, nick, content, signature, link, count_answers, sess_id)
                                     VALUES ('$content_topic[0]','$content_topic[1]','$content_topic[2]','$content_topic[3]','$content_topic[4]','$content_topic[5]','$content_topic[6]','$content_topic[7]')";
            $this->setQuery($sql);
        }

        function add_new_answer($answer)
        {
            $sql = "INSERT INTO ".$this->module_id."_list_answers (time_create, id_topic, nick, content, signature, link, sess_id)
                                                 VALUES  ('$answer[0]','$answer[1]','$answer[2]','$answer[3]','$answer[4]','$answer[5]','$answer[6]')";
            $this->setQuery($sql);
        }

        function increment_decrement_count_answers($id_topic,$count)
        {
            $sql = "UPDATE ".$this->module_id."_list_topics SET count_answers=count_answers+'$count' WHERE time_create=$id_topic";
            $this->setQuery($sql);
        }

        function edit_answer($mass_vars)
        {
            $id = intval($mass_vars["user_id"]);
            $nick = $mass_vars["nick"];
            $content = $mass_vars["content"];
            $signature = $mass_vars["signature"];
            $link = $mass_vars["link"];

            $sql = "UPDATE ".$this->module_id."_list_answers SET nick='$nick', content='$content', signature='$signature', link='$link' WHERE time_create=$id";
            $this->setQuery($sql);
        }

        function delete_answer($answer_id)
        {
            $sql = "DELETE FROM ".$this->module_id."_list_answers WHERE time_create=$answer_id";
            $this->setQuery($sql);
        }

        function get_all_mass_answers()
        {
            $mass = array();
            $sql = "SELECT * ".$this->module_id."_FROM list_answers";
            $result = $this->getQuery($sql);

            if($row = $this->fetch_array($result))
            {
                $mass[] = $row;
            }
            return $mass;
        }
    }
    
    class forum_db
    {
        var $db;

        function forum_db($params)
        {
            switch($params["type_db"])
            {
                case "files":
                     $this->db = new FILES();
                     break;

                case "sqlite":
                     $this->db = new SQLITE();
                     break;

                case "mysql":
                     $this->db = new mysql($params["host_db"],$params["user_db"],$params["passwd_db"],$params["db_name"], $params["module_id"]);
                     break;
            }
        }
        
        function getTopics()
        {
           $mass_topics = $this->db->getTopics();
           return $mass_topics;
        }
        
        function getTopicById($id_topic)
        {
           $topic = $this->db->get_topic($id_topic);
           return $topic;
        }

        function addTopic($mass_vars)
        {
           $content_topic = array(time(),$mass_vars["new_topic"],$mass_vars["nick"],$mass_vars["content"],$mass_vars["signature"],$mass_vars["link"],0,session_id());
           $this->db->addTopic($content_topic);
        }

        function getAnswersByTopic($id_topic)
        {
           $mass_answers = $this->db->getAnswersByTopic($id_topic);
           return $mass_answers;
        }
        
        function getAllAnswers()
        {
           $mass_answers = $this->db->get_all_mass_answers();
           return $mass_answers;
        }

        function add_new_answer($answer)
        {
           $this->db->add_new_answer($answer);
           $this->db->increment_decrement_count_answers(intval($answer[1])/*id_topic*/,1);
        }
        
        function edit_answer($mass)
        {
           $this->db->edit_answer($mass);
        }
        
        function delete_answer($answer_id,$topic_id)
        {
           $this->db->delete_answer($answer_id);
           $this->db->increment_decrement_count_answers(intval($topic_id)/*id_topic*/,-1);
        }
        
        function close_db()
        {
        	$this->db->close_db();
        }
     }
?>
